org.eclipse.incquery.runtime.base.core

## Class NavigationHelperVisitor

- java.lang.Object
- - org.eclipse.incquery.runtime.base.comprehension.EMFVisitor
  - - org.eclipse.incquery.runtime.base.core.NavigationHelperVisitor

- Direct Known Subclasses:
    NavigationHelperVisitor.ChangeVisitor, NavigationHelperVisitor.TraversingVisitor

      public abstract class NavigationHelperVisitor
      extends EMFVisitor

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `NavigationHelperVisitor.ChangeVisitor` A visitor for processing a single change event.
    `static class` | `NavigationHelperVisitor.TraversingVisitor` A visitor for a single-pass traversal of the whole model, processing only the given types and inserting them.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `pruneFeature(org.eclipse.emf.ecore.EStructuralFeature feature)` Returns true if the given feature should not be traversed (interesting esp.
    `boolean` | `pruneSubtrees(org.eclipse.emf.ecore.EObject source)` Returns true if the contents of an object should be pruned (and not explored by the visitor)
    `boolean` | `pruneSubtrees(org.eclipse.emf.ecore.resource.Resource source)` Returns true if the contents of a resource should be pruned (and not explored by the visitor)
    `void` | `visitAttribute(org.eclipse.emf.ecore.EObject source, org.eclipse.emf.ecore.EAttribute feature, java.lang.Object target)`
    `void` | `visitElement(org.eclipse.emf.ecore.EObject source)`
    `void` | `visitInternalContainment(org.eclipse.emf.ecore.EObject source, org.eclipse.emf.ecore.EReference feature, org.eclipse.emf.ecore.EObject target)`
    `void` | `visitNonContainmentReference(org.eclipse.emf.ecore.EObject source, org.eclipse.emf.ecore.EReference feature, org.eclipse.emf.ecore.EObject target)`
    `void` | `visitProxyReference(org.eclipse.emf.ecore.EObject source, org.eclipse.emf.ecore.EReference reference, org.eclipse.emf.ecore.EObject targetObject, java.lang.Integer position)` Called after visiting the reference, if the target is a proxy.

    - ### Methods inherited from class org.eclipse.incquery.runtime.base.comprehension.EMFVisitor

      `preOrder, visitResource, visitTopElementInResource`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### pruneSubtrees

          public boolean pruneSubtrees(org.eclipse.emf.ecore.EObject source)

      Description copied from class: `EMFVisitor`
      Returns true if the contents of an object should be pruned (and not explored by the visitor)
      Overrides:
        `pruneSubtrees` in class `EMFVisitor`

    - #### pruneSubtrees

          public boolean pruneSubtrees(org.eclipse.emf.ecore.resource.Resource source)

      Description copied from class: `EMFVisitor`
      Returns true if the contents of a resource should be pruned (and not explored by the visitor)
      Overrides:
        `pruneSubtrees` in class `EMFVisitor`

    - #### pruneFeature

          public boolean pruneFeature(org.eclipse.emf.ecore.EStructuralFeature feature)

      Description copied from class: `EMFVisitor`
      Returns true if the given feature should not be traversed (interesting esp. if multi-valued)
      Overrides:
        `pruneFeature` in class `EMFVisitor`

    - #### visitElement

          public void visitElement(org.eclipse.emf.ecore.EObject source)

      Overrides:
        `visitElement` in class `EMFVisitor`

    - #### visitAttribute

          public void visitAttribute(org.eclipse.emf.ecore.EObject source,
                                     org.eclipse.emf.ecore.EAttribute feature,
                                     java.lang.Object target)

      Overrides:
        `visitAttribute` in class `EMFVisitor`

    - #### visitInternalContainment

          public void visitInternalContainment(org.eclipse.emf.ecore.EObject source,
                                               org.eclipse.emf.ecore.EReference feature,
                                               org.eclipse.emf.ecore.EObject target)

      Overrides:
        `visitInternalContainment` in class `EMFVisitor`

    - #### visitNonContainmentReference

          public void visitNonContainmentReference(org.eclipse.emf.ecore.EObject source,
                                                   org.eclipse.emf.ecore.EReference feature,
                                                   org.eclipse.emf.ecore.EObject target)

      Overrides:
        `visitNonContainmentReference` in class `EMFVisitor`

    - #### visitProxyReference

          public void visitProxyReference(org.eclipse.emf.ecore.EObject source,
                                          org.eclipse.emf.ecore.EReference reference,
                                          org.eclipse.emf.ecore.EObject targetObject,
                                          java.lang.Integer position)

      Description copied from class: `EMFVisitor`
      Called after visiting the reference, if the target is a proxy.
      Overrides:
        `visitProxyReference` in class `EMFVisitor`
        `position` - optional: known position in multivalued collection (for more efficient proxy resolution)